DAT programName         byte "Max7219Demo131226c", 0
CON
{{
  ******* Public Notes *******

  Author: Duane Degn
  Date: December 26, 2013

  MIT License

  An attempt to control an 8x8 LED array with a MAX7219 chip.

  The number of arrays may be changed by changing the
  "ARRAYS_IN_USE" constant.

  The constants marked with "User changeable" may be
  changed based on the LED project is configured.

  The code in this program is pretty much all original.
  I did look at Hover1's 7-segment MAX7219 code. Which
  helped get me started.
 
}}
{
  ******* Private Notes *******

   131225c Displays a message one character at a time.
   25c Appears to be working.
   25d Change font with each message.
   25e Try to rotate text.
   25e Didn't work.
   25g Rotation worked.
   25h Try to add scrolling.
   25j Working reasonably well.
   25k Seems to scroll single rotated array correctly.
   25l Try adding additional array.
   25l Doesn't work. The two displays are almost the
   same. Both have lots of glitches.
   25m Better but a lot of noise on the last display.
   25n Much worse.
   25o Abandon 25n.
   26a Start moving MAX7219 specific code to a
   child object.
   26a Appears to work correctly.
   26b Make the split.
   26b Appears to work correctly using the child
   object "Max7219MultiArray131226b".
   26c Start adding a few features.
   
}
CON ' Parent Constants                    
                     
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000

  CS_PIN = 18                   '' User changeable
  DATA_PIN = 17                 '' User changeable
  CLOCK_PIN = 16                '' User changeable

  ARRAYS_IN_USE = 2             '' User changeable
  
  QUOTE = 34

VAR
 
  byte arrayBuffer[Leds#LINES_IN_ARRAY * ARRAYS_IN_USE]

OBJ

  Leds : "Max7219MultiArray131226c"
  
PUB Demo

  Leds.Init(CLOCK_PIN, DATA_PIN, CS_PIN, ARRAYS_IN_USE, @arrayBuffer)
  waitcnt(clkfreq * 2 + cnt) ' time to open terminal window

  MainLoop
  
PUB MainLoop 
   
  repeat

    Leds.SetFont(Leds#FREE_DESIGN)
    Leds.ScrollRotatedText(@message0)
 
    Leds.SetFont(Leds#ASCII_0508)
    Leds.ScrollRotatedText(@message0)

DAT

message0                byte "Merry Christmas  ", 0